<?php
include(dirname(__FILE__, 5) . '/wp-load.php');

get_header(); 

defined( 'ABSPATH' ) || exit;

global $product, $api_path; 

if ( post_password_required() ) {
  echo get_the_password_form(); // WPCS: XSS ok.
  return;
}
$length = 8;
$min = 1 . str_repeat(0, $length-1);
$max = str_repeat(9, $length);
$random = mt_rand($min, $max); 
if (!isMobileDevice()) {
  wp_enqueue_style( 'designer-style', $api_path . 'static/css/inx-main.css?rvn=' . $random , false, '1.0.0' );
}
?>
<script type="text/javascript">
  var thisURL = <?php echo json_encode($api_path); ?>; 
  var isMobile = /iPhone|iPad|iPod|Android/i.test(navigator.userAgent);
  var browserWdth = window.innerWidth;
  if (isMobile || browserWdth < 1024 || navigator.userAgent.match(/Mac/) && navigator.maxTouchPoints && navigator.maxTouchPoints > 2) {
      const allInBody = document.querySelectorAll('body > *');
      for (const element of allInBody) {
        element.remove();
      }
      var elemDiv = document.createElement('div');
      elemDiv.id = "root";
      document.body.appendChild(elemDiv);
      //add links dynamically
      var head = document.getElementsByTagName('HEAD')[0];
      var cssFiles = ["inx-mobile.chunk.css", "inx-mobile-main.css"];
      var arrayLength = cssFiles.length;
      for (var i = 0; i < arrayLength; i++) {
        var link = document.createElement('link');
        link.rel = 'stylesheet';
        link.type = 'text/css';
        link.href = thisURL + "mobile/static/css/" + cssFiles[i];
        head.appendChild(link);

        console.log(cssFiles[i]);
        //Do something
      }

    loadRPCJS(thisURL + "config.js?rvn=" + Math.floor(1e8 * Math.random()), true);
    loadRPCJS(thisURL + "mobile/static/js/runtime-main.inx-mobile.js?rvn=" + Math.floor(1e8 * Math.random()), true);
    loadRPCJS(thisURL + "mobile/static/js/inx-mobile.chunk.js?rvn=" + Math.floor(1e8 * Math.random()), true);
    loadRPCJS(thisURL + "mobile/static/js/inx-mobile-main.js?rvn=" + Math.floor(1e8 * Math.random()), true);
  }
  
  function loadRPCJS(FILE_URL, async = true) {
    let scriptEle = document.createElement("script");
    scriptEle.setAttribute("src", FILE_URL);
    scriptEle.setAttribute("type", "text/javascript");
    scriptEle.setAttribute("async", async);
    document.body.appendChild(scriptEle);

    // success event 
    scriptEle.addEventListener("load", () => {
      console.log("File loaded")
    });
    // error event
    scriptEle.addEventListener("error", (ev) => {
      console.log("Error on loading file", ev);
    });
  }
</script>
<div id="root" style="min-height:600px;"></div>
<?php
  if (!isMobileDevice()) {
    wp_enqueue_script( 'designer-script1', $api_path . 'config.js?rvn=' . $random, array(), '1.0.0', true );
    wp_enqueue_script( 'designer-script', $api_path . 'static/js/inx-main.js?rvn=' . $random, array(), '1.0.0', true );
  } 
get_footer(); 

function isMobileDevice() {
    $userAgent = $_SERVER['HTTP_USER_AGENT'];
    $mobileDevices = [
        'iPhone', 'iPad', 'Android', 'BlackBerry', 'Windows Phone', 'Mobile', 'webOS'
    ];
    
    foreach ($mobileDevices as $device) {
        if (stripos($userAgent, $device) !== false) {
            return true;
        }
    }
    return false;
}
  
?>

<style>
.col-full{
    max-width: 100%!important;
}
.content-area{
    width: 100%!important;
}
</style>